#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		sendPrivate(p, "------Limit Bot------");
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SysOp:
			{	// SysOp-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level command
				sendPrivate(p, "Smod Commands: !maxlimits [Freq] !attachlimits [Freq] !printfreqs");
				sendPrivate(p, "Smod Commands: !setattachlimit [Freq:Ship:NoAttach] !setshiplimit [Freq:Ship:Limit]");
			}
		case OP_Moderator:
			{	// Moderator-level commands
				sendPrivate(p, "Mod Commands: !shiplimitstatus [ON/OFF] !attachlimitstatus [ON/OFF]");	
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
				String Message= "Player Commands:";
				if(ShipLimitsStatus || AttachLimitsStatus)
				{
					if(ShipLimitsStatus)
					{Message+=" !shiplimits [Freq]";}
					if(AttachLimitsStatus)
					{Message+=" !myattachlimit";}
				}
				else
				{Message+= " Disabled";}
				sendPrivate(p, Message);
			}
		}
		sendPrivate(p, "---------------------");

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands		
			if(c->checkParam("setshiplimit"))
			{
				sendPrivate(p, "Command !setshiplimit [Freq:Ship:Limit]: Change a specific ship's regulation limit. Ex- !setshiplimit 1:1:10 ,would set Freq 1's Warbird with a regulation of 10. Limit can also be the word OFF to turn off a limit. Ex- !setshiplimit 1:1:OFF");
			}
			else if(c->checkParam("maxlimits"))
			{
				sendPrivate(p, "Command !maxlimits [Freq]: Reports the amount of players in a limited ship and the max amounts allowed for each ship of the freq");
			}
			else if(c->checkParam("setattachlimit"))
			{
				sendPrivate(p, "Command !setattachlimit [Freq:Ship:NoAttach]: Change a specific ship's regulation on attaches. Ex- !setattachlimit 1:1:3,5,8 , would make Freq 1's Warbird unable to attach to ships 1,5,8");
			}
			else if(c->checkParam("attachlimits"))
			{
				sendPrivate(p, "Command !attachlimits [Freq]: Reports all the attach limits for each ship in that freq");
			}
			else if(c->checkParam("printfreqs"))
			{
				sendPrivate(p, "Command !printfreqs: Reports the freqs that have ship limits");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if(c->checkParam("shiplimitstatus"))
			{
				sendPrivate(p, "Command !shiplimitstatus [ON/OFF]: Turns on the bot's ability to regulate the amount of specific ships. Ex- !shiplimitstatus on");
			}
			else if(c->checkParam("attachlimitstatus"))
			{
				sendPrivate(p, "Command !attachlimitstatus [ON/OFF]: Turns on the bot's ablility to regualte ship attaches to specific ships. Ex- !attachlimitstatus on");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if(c->checkParam("shiplimits"))
			{
				sendPrivate(p, "Command !shiplimits [Freq]: Prints the report of the current ship limits for Freq. Leave Freq blank for your freq\'s ship limits");
			}
			else if(c->checkParam("myattachlimit"))
			{
				sendPrivate(p, "Command !myattachlimit: Prints out the ships that your ship can not attach to");
			}
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if(c->check("setshiplimit") || c->check("setshiplimits")) //set a max limit for a specific ship
			{
				String LimitStr= c->final; //get the final part of string
				String FreqNum= LimitStr.split(':');
				String ShipStr= LimitStr.split(':'); //split the string in half

				String Message;
				if(isNumeric(FreqNum) && ShipStr[0] >= '1' && ShipStr[0] <= '8') //if the ship is 1-8
				{
					FreqShips *Freq=FindFreq(FreqNum.toInteger());
					if(Freq != NULL)
					{
						Uint16 ShipNumber= ShipStr.toInteger(1)-1; //convert string to int
						Message="Ship#";
						Message+=ShipStr;
						Message+=": ";
						Message+=Freq->Ship[ShipNumber].ShipName;
						Message+=" limit has been changed to ";

						if(LimitStr == "off") //if the command was to turn off the limit
						{
							Message+= "OFF";
							Freq->Ship[ShipNumber].ShipLimit=false;//turn off limit
						} 
						else //the command wasnt off
						{
							if(isNumeric(LimitStr)) //if the limit is a number
							{		
								Message+=LimitStr;
	
								StopShipLimits(); //stop the limits to bring them back to thier original value
								Freq->Ship[ShipNumber].ShipLimit=true;
								Freq->Ship[ShipNumber].MaxShips= Uint16(LimitStr.toInteger()); //change the value
								StartShipLimits();// start the ship limits again
							}
							else
							{Message= "Invalid Ship Limit, Format !setshiplimit Freq:Ship:Limit";}
						}
					}
					else
					{Message= "Invalid Freq, Format !setshiplimit Freq:Ship:Limit";}
				}
				else
				{Message= "Invalid Ship Number or Freq Number, Format !setshiplimit Freq:Ship:Limit";}

				sendPrivate(p, Message); //send notice
			}
			else if(c->check("maxlimits") || c->check("maxlimit")) //find the max limits for the ships
			{
				String Message; //outputs message
				String Lines=   "|------------------------------------------------------------|";
				sendPrivate(p, Lines); //send the line bar
				if(isNumeric(c->final))
				{
					Uint16 FreqNum= getInteger(c->final,10);
					FreqShips *Freq=FindFreq(FreqNum);

					if(Freq != NULL)
					{
						_listnode <Player> *pl; //playerlist
						Uint16 ShipCount; //number of people in a specific ship

						for(Uint16 i=0;i<8;i++) //cycle through ships
						{
							if(Freq->Ship[i].ShipLimit) //if the ship has a limit
							{
								Message= "| Ship#"; //output a nice message
								Message+=i+1;
								Message+=": ";
								Message+=Freq->Ship[i].ShipName;
								Message+="- ";
								ShipCount=0;

								if(ShipLimitsStatus) //if the shiplimits are off, report only max ships
								{	
									pl=playerlist->head;
									while(pl)
									{
										if((pl->item->team == FreqNum) && (pl->item->ship == i))
										{ShipCount++;}
										pl= pl->next;
									}
									Message+= ShipCount;
									Message+= " Players of ";
								}
								Message+= Freq->Ship[i].MaxShips + ShipCount;
								Message+= " Max Ships";
		
								while(Message.len+1 < Lines.len) //add spaces to make nice text box
								{Message+=" ";}
								Message+= "|";
								sendPrivate(p,Message);//send the message line
							}	
						}	
						if(!Message.len)
						{sendPrivate(p,"|                  There are no ship limits                  |");}
					}
					else
					{sendPrivate(p,"|                That freq has no ship limits                |");}
				
				}
				else
				{sendPrivate(p,"|       Invalid freq number: Format- !maxlimits [Freq]       |");}
				sendPrivate(p, Lines); //send the line bar
			}
			else if(c->check("setattachlimit") || c->check("setattachlimits")) //set the attach limits for a ship
			{
				String NoAttachStr= c->final;
				String FreqNum= NoAttachStr.split(':');
				String ShipNum= NoAttachStr.split(':');
				
				if(isNumeric(FreqNum) && (ShipNum[0] >= '1' && ShipNum[0] <= '8'))
				{
					FreqShips *Freq=FindFreq(FreqNum.toInteger());
					if(Freq != NULL)
					{
						Sint32 k; //used for array index and loop control
						Uint16 i= getInteger(ShipNum,10) -1; //get the index value of the ship
						for(k=0;k<8;k++) //turn all NoAttach to false, prepare for new ones
						{Freq->Ship[i].NoAttach[k]=false;}
	
						 //k acts as a safe guard for invalid input
						for(k=NoAttachStr.len-1;k >= 0;k--) //cycle through buffer
						{
							if (NoAttachStr[k] >= '1' && NoAttachStr[k] <= '8') //if the ship is a ship 1-8
							{
								Freq->Ship[i].NoAttach[NoAttachStr[k]-'1']= true; //convert char to index value
							}
						}	
	
						bool ShipFound=false;
						NoAttachStr= "Ship#"; //make nice message
						NoAttachStr+= i+1;
						NoAttachStr+= ":";
						NoAttachStr+= Freq->Ship[i].ShipName;
						NoAttachStr+= " now can not attach to ";

						for(k=0;k<8;k++)
						{
							if(Freq->Ship[i].NoAttach[k])
							{
								ShipFound=true;
								NoAttachStr+= "(Ship#";
								NoAttachStr+= k+1;
								NoAttachStr+= ":";
								NoAttachStr+=Freq->Ship[k].ShipName;
								NoAttachStr+=")";
							}	
						}
						if(!ShipFound)
						{NoAttachStr= "Ship\'s Attach Limit Disabled";}
						else
						{StartAttachLimits();}	
					}
					else
					{
						NoAttachStr="Invalid Freq, Format !setattachlimit Freq:Ship:Limit";
					}
				}
				else //if there was a invalid ship number
				{NoAttachStr= "Invalid Ship Number or Freq Number, Format !setattachlimit Freq:Ship:NoAttachs";}

				sendPrivate(p,NoAttachStr); //output the string
			}
			else if(c->check("attachlimits") || c->check("attachlimit")) //reports all attach limits for freq
			{
				String Message=c->final;
				if(isNumeric(Message))
				{
					FreqShips *Freq=FindFreq(Message.toInteger());
					if(Freq != NULL)
					{
						bool ShipFound;
						sendPrivate(p,"----Attach Limits---");
						for(Uint16 i=0;i<8;i++) //cycle through ships
						{
							ShipFound=false;//true if a NoAttach ship is found
							Message= "Ship#";//a nice message printout
							Message+=i+1;
							Message+=":";
							Message+=Freq->Ship[i].ShipName;
							Message+="-  ";
							for(Uint16 k=0;k<8;k++) //cycle through NoAttach Ships
							{
								if(Freq->Ship[i].NoAttach[k])
								{
									ShipFound=true;
									Message+=k+1;
									Message+=", ";
								}
							}
							if(!ShipFound) //if there wasnt a NoAttach ship found, then that ship has no limit
							{Message+= "No Attach Limit";}
							else
							{Message[Message.len-2]=' ';}
							sendPrivate(p,Message);
						}
					}
					else
					{sendPrivate(p,"That Freq has no limits!");}
				}
				else
				{sendPrivate(p,"You must specify a freq number! Format- !attachlimits 1");}
			}
			else if(c->check("printfreqs") || c->check("printfreq")) //print all the limited freqs
			{
				_listnode <FreqShips> *fl= FreqList.head;
				String Message;

				if(fl != NULL)
				{
					Message="Limited Freq(s): ";
					while(fl)
					{
						Message+=" (Freq# ";
						Message+=fl->item->FreqNum;
						Message+=")";
						fl=fl->next;
					}
				}
				else
				{Message="There are no limited freqs!";}

				sendPrivate(p,Message);
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if(c->check("shiplimitstatus")) //to change the status of the ship limits, ON or OFF
			{
				String limits= c->final; //get final portion of string

				if(limits.IsEmpty()) //if its empty
				{
					limits= "Ship Limits Status: "; //then report the current status of shiplimits
					if(ShipLimitsStatus)
					{limits+= "ON";}
					else
					{limits+= "OFF";}		
				}
				else //if the string has a command in it
				{
					if(limits == "on") //if the command was on
					{
						//then enable the bot
						if(ShipLimitsStatus)
						{limits= "Ship Limits Are Already Enabled";}
						else
						{
							ShipLimitsStatus=true;
							StartShipLimits();
							limits= "Ship Limits Turned ON Successfully";
						}
					}
					else //if the command was off
					{
						if(limits == "off")//then disable the bot
						{
							if(ShipLimitsStatus)
							{	
								ShipLimitsStatus=false;
								StopShipLimits();
								limits= "Ship Limits Turned OFF Successfully";
							}
							else
							{limits= "Ship Limits Are Already Disabled";}
						}
						else //if it wasnt a On or OFF command, then it was invalid
						{limits= "Invalid command for !shiplimitstatus , use ON or OFF. Ex- !shiplimitstatus on";}
					}
				}
				sendPrivate(p,limits); //send the limits confermation message
			}
			else if(c->check("attachlimitstatus")) //turns ON or OFF attach limits
			{
				String limits= c->final; //get the final portion of the string

				if(limits.IsEmpty()) //if the final part was empty
				{
					limits= "Attach Limits Status: "; //report the current status
					if(AttachLimitsStatus)
					{limits+= "ON";}
					else
					{limits+= "OFF";}		
				}
				else //if the string had a command
				{
					if(limits == "on") //if the command was ON
					{
						//then turn on attach limits
						if(AttachLimitsStatus)
						{limits= "Attach Limits Are Already Enabled";}
						else
						{
							AttachLimitsStatus=true;
							StartAttachLimits();
							limits= "Attach Limits Turned ON Successfully";
						}
					}
					else
					{
						if(limits == "off") //if the command was OFF
						{
							//then turn OFF attach limits
							if(AttachLimitsStatus)
							{	
								AttachLimitsStatus=false;
								limits= "Attach Limits Turned OFF Successfully";
							}
							else
							{limits= "Attach Limits Are Already Disabled";}
						}
						else //if the command wasnt ON or OFF, then the command was invalid
						{limits= "Invalid command for !attachlimitstatus , use ON or OFF. Ex- !attachlimitstatus on";}
					}
				}
				sendPrivate(p,limits); //send confermation
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about") || c->check("version")) //about this sexy bot
			{
				sendPrivate(p, "Ship Limits and Attach Behavior (v1.2) By: 50% Packetloss (FiftyPacketloss@socal.rr.com)");
			}
			else if(c->check("shiplimits") || c->check("shiplimit")) //reports the ship limits
			{
				if(ShipLimitsStatus) //if the shiplimits are ON
				{
					String Lines=   "|-----------------------------------------------------------|"; //For the box around the data
					String ShipStr= "|                 (Number of Ships Allowed)                 |"; //Holds the ship names
					bool Found=false;
					String FreqNum= c->final;
					
				
					FreqShips *Freq;
					if(!FreqNum.IsEmpty() && isNumeric(FreqNum))
					{
						sendPrivate(p,"Checking Ship Limit for Freq Number " + FreqNum);
						Freq=FindFreq(FreqNum.toInteger());
					}
					else
					{
						sendPrivate(p,"Checking Ship Limit for Freq Number " + (String)p->team);
						Freq=FindFreq(p->team);
					}
					
					sendPrivate(p,Lines);
					sendPrivate(p,ShipStr);
					sendPrivate(p,Lines);

					if(Freq != NULL)
					{
						for(Uint16 i=0;i<8;i++) //index the array
						{
							if(Freq->Ship[i].ShipLimit) //if you find a ship that has a limit on it
							{
								Found=true;
								ShipStr= "| Ship#"; //add a | to the output string
								ShipStr+=i+1;
								ShipStr+=": ";
								ShipStr+= Freq->Ship[i].ShipName; //add the ship name, ex- | Ship#1: Warbird
								ShipStr+= " ("; //add dash, ex- | Ship #1: Warbird (
								ShipStr+= Freq->Ship[i].MaxShips; //add number, ex- | Ship #1: Warbird(24
								ShipStr+= ")"; //ex- | Ship #1: Warbird(24)
	
								while(ShipStr.len+1 < Lines.len) //add in ' ' space characters
								{ShipStr+= " ";}

								ShipStr+= "|"; //add '|'
								sendPrivate(p,ShipStr);
							}
						}
					}

					if(!Found) //if no ship was gathered, then there isnt a limit
					{
						sendPrivate(p,"|                No Ship Limits For the Freq!               |");
					}
					sendPrivate(p,Lines);
				}
				else //ship limits are off
				{sendPrivate(p, "Ship Limits are Disabled!");}	
			}
			else if(c->check("myattachlimit") || c->check("myattachlimits")) //reports the attach limits on your ship, all the ships you cant attach to
			{
				String ShipMsg; //the notification message
				if(AttachLimitsStatus) //if attach limits are on
				{	
					if(p->ship !=8) //if player is not a spectator
					{
						FreqShips *Freq=FindFreq(p->team);
						bool AttachFound=false; //true if a attach ship is found
						if(Freq != NULL)
						{
							ShipMsg="You May Not Attach to Ship(s):";
							for(Uint16 i=0;i<8;i++) //index NoAttach[i]
							{
								if(Freq->Ship[p->ship].NoAttach[i]) //if the ship cant attach
								{
									AttachFound=true; //found a ship
									ShipMsg+=" (Ship#"; //make a nice message
									ShipMsg+= i+1;
									ShipMsg+= ":";
									ShipMsg+= Freq->Ship[i].ShipName;
									ShipMsg+=")";
								}
							}
						}

						if(!AttachFound) //if no attach was found, then you can attach to everything
						{
							ShipMsg= "Your Ship, ";
							ShipMsg+= Freq->Ship[p->ship].ShipName;
							ShipMsg+= ", can attach to every ship";
						}
					}
					else //if player is in spectator mode
					{ShipMsg= "You must get in a ship to have an attach limit";}
				}
				else //if the attach limit is off
				{ShipMsg= "Attach Limits are Disabled";}

				sendPrivate(p,ShipMsg); //send notification message
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
